<?php



if(!defined('IN_DISCUZ')) {

	exit('Access Denied');

}

class alipayopen_pay extends api_pay{

	protected $config;

	protected $ismobile = false;

	public function __construct() {

		parent::__construct();

		$this->config = $this->getconfig();

	}

	

	public function generate_xh_hash(array $datas,$hashkey){
	    ksort($datas);
	    reset($datas);

	    $pre =array();
	    foreach ($datas as $key => $data){
	        if(is_null($data)||$data===''){continue;}
	        if($key=='hash'){
	            continue;
	        }
	        $pre[$key]=stripslashes($data);
	    }

	    $arg  = '';
	    $qty = count($pre);
	    $index=0;

	    foreach ($pre as $key=>$val){
	        $arg.="$key=$val";
	        if($index++<($qty-1)){
	            $arg.="&";
	        }
	    }

	    return md5($arg.$hashkey);
	}

	private function is_alipay_app(){
	    return strripos($_SERVER['HTTP_USER_AGENT'],'micromessenger');
	}


	public function setorder($order_id, $price, $subject, $body, $showurl){

		global $_G;

		$data=array(
		    'version'   => '1.1',
		    'lang'       => 'zh-cn',
		    'is_app'    => 'N',
		    'plugins'   => 'dz-alipay',
		    'appid'     => $this->config['appid'],
		    'trade_order_id'=> $order_id,
		    'payment'   => 'alipay',
		    'total_fee' => $price,
		    'title'     => "#$order_id",
		    'description'=> null,
		    'time'      => time(),
		    'notify_url'=> $_G['siteurl'].'source/plugin/dc_pay/api/alipayopen/alipayopen_notify.php',
		    'return_url'=> $_G['siteurl'].'source/plugin/dc_pay/api/alipayopen/alipayopen_return.php?orderid='.$order_id,
		    'callback_url'=>$_G['siteurl'],
		    'redirect'=>1,
		    'nonce_str' => str_shuffle(time())
		);
		$hashkey          = $this->config['appsecret'];
		$data['hash']     = $this->generate_xh_hash($data,$hashkey);

		$this->args = $data;
	}

	public function create_payurl(){
		return array(
			'gateway'=>$this->config['transaction_url'].'/payment/do.html',
			'args'=>$this->args,
		);
	}

	public function getpayinfo(){
		define('TRADENO', isset($_POST['transaction_id'])?$_POST['transaction_id']:null);
		define('ORDERID', isset($_POST['trade_order_id'])?$_POST['trade_order_id']:$_GET['orderid']);

		return array(
			'succeed'=>'success',

			'fail'=>'fail'

		);

	}
	public function pricecheck($price){
	    return true;
	}
	public function notifycheck(){
	    $data = $_POST;

	    if(isset($data['plugins'])&&$data['plugins']!='dz-alipay'){
	        return false;
	    }

	    $appkey =$this->config['appsecret'];
	    $hash = $this->generate_xh_hash($data,$appkey);
	    return $data['hash']==$hash;
	}

}

class alipayopen_mobilepay extends api_pay{
	protected $config;
	protected $ismobile = true;

	public function __construct() {

		parent::__construct();

		$this->config = $this->getconfig();

	}

	public function generate_xh_hash(array $datas,$hashkey){
	    ksort($datas);
	    reset($datas);

	    $pre =array();
	    foreach ($datas as $key => $data){
	        if(is_null($data)||$data===''){continue;}
	        if($key=='hash'){
	            continue;
	        }
	        $pre[$key]=stripslashes($data);
	    }

	    $arg  = '';
	    $qty = count($pre);
	    $index=0;

	    foreach ($pre as $key=>$val){
	        $arg.="$key=$val";
	        if($index++<($qty-1)){
	            $arg.="&";
	        }
	    }

	    return md5($arg.$hashkey);
	}

	private function is_alipay_app(){
	    return strripos($_SERVER['HTTP_USER_AGENT'],'micromessenger');
	}
		public function setorder($order_id, $price, $subject, $body, $showurl){

		global $_G;

		$data=array(
		    'version'   => '1.1',
		    'lang'       => 'zh-cn',
		    'is_app'    => 'Y',
		    'plugins'   => 'dz-alipay',
		    'appid'     => $this->config['appid'],
		    'trade_order_id'=> $order_id,
		    'payment'   => 'alipay',
		    'total_fee' => $price,
		    'title'     => "#$order_id",
		    'description'=> null,
		    'time'      => time(),
		    'notify_url'=> $_G['siteurl'].'source/plugin/dc_pay/api/alipayopen/alipayopen_notify.php',
		    'return_url'=> $_G['siteurl'].'source/plugin/dc_pay/api/alipayopen/alipayopen_return.php?orderid='.$order_id,
		    'callback_url'=>$_G['siteurl'],
		    'redirect'=>1,
		    'nonce_str' => str_shuffle(time())
		);
		$hashkey          = $this->config['appsecret'];
		$data['hash']     = $this->generate_xh_hash($data,$hashkey);

		$this->args = $data;
	}
	public function create_payurl(){
		return array(
			'gateway'=>$this->config['transaction_url'].'/payment/do.html',
			'args'=>$this->args,
		);
	}

	public function getpayinfo(){
		define('TRADENO', isset($_POST['transaction_id'])?$_POST['transaction_id']:null);
		define('ORDERID', isset($_POST['trade_order_id'])?$_POST['trade_order_id']:$_GET['orderid']);

		return array(
			'succeed'=>'success',

			'fail'=>'fail'

		);

	}
	public function pricecheck($price){
	    return true;
	}
	public function notifycheck(){
	    $data = $_POST;

	    if(isset($data['plugins'])&&$data['plugins']!='dz-alipay'){
	        return false;
	    }

	    $appkey =$this->config['appsecret'];
	    $hash = $this->generate_xh_hash($data,$appkey);
	    return $data['hash']==$hash;
	}
}

?>
