<?php

if (! defined('IN_DISCUZ')) {
    exit('Access Denied');
}
ini_set('display_errors', 'On');
    error_reporting(E_ALL);
class wechatopen_pay extends api_pay
{

    protected $config;

    protected $ismobile = false;

    public function __construct()
    {
        parent::__construct();
        $this->config = $this->getconfig();
    }

    private function http_post($url, $data)
    {
        if (! function_exists('curl_init')) {
            throw new Exception('phpδ��װcurl���', 500);
        }
        global $_G;
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_TIMEOUT, 60);
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_REFERER, $_G['siteurl']);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_setopt($ch, CURLOPT_HEADER, FALSE);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_POST, TRUE);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
        $response = curl_exec($ch);
        $httpStatusCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);
        $error = curl_error($ch);
        curl_close($ch);
        if ($httpStatusCode != 200) {
            throw new Exception("invalid httpstatus:{$httpStatusCode} ,response:$response,detail_error:" . $error, $httpStatusCode);
        }
        return $response;
    }

    public function generate_xh_hash(array $datas, $hashkey)
    {
        ksort($datas);
        reset($datas);
        $pre = array();
        foreach ($datas as $key => $data) {
            if (is_null($data) || $data === '') {
                continue;
            }
            if ($key == 'hash') {
                continue;
            }
            $pre[$key] = stripslashes($data);
        }
        $arg = '';
        $qty = count($pre);
        $index = 0;
        foreach ($pre as $key => $val) {
            $arg .= "$key=$val";
            if ($index ++ < ($qty - 1)) {
                $arg .= "&";
            }
        }
        return md5($arg . $hashkey);
    }

    private function is_wechat_app()
    {
        return strripos($_SERVER['HTTP_USER_AGENT'], 'micromessenger');
    }

    public function setorder($order_id, $price, $subject, $body, $showurl)
    {
        global $_G;
        $data = array(
            'version' => '1.1',
            'lang' => 'zh-cn',
            'is_app' => 'N',
            'plugins' => 'dz-wechat',
            'appid' => $this->config['appid'],
            'trade_order_id' => $order_id,
            'payment' => 'wechat',
            'total_fee' => $price,
            'title' => iconv("UTF-8", "GBK//IGNORE", $subject),
            'description' => null,
            'time' => time(),
            'notify_url' => str_replace('http://','https://',$_G['siteurl']) . 'source/plugin/dc_pay/api/wechatopen/wechatopen_notify.php',
            'return_url' => str_replace('http://','https://',$_G['siteurl']) . 'source/plugin/dc_pay/api/wechatopen/wechatopen_return.php?orderid=' . $order_id,
            'callback_url' => str_replace('http://','https://',$_G['siteurl']),
            'redirect' => 1,
            'nonce_str' => str_shuffle(time())
        );
        $hashkey = $this->config['appsecret'];
        $data['hash'] = $this->generate_xh_hash($data, $hashkey);
        $this->args = $data;
    }

    public function create_payurl()
    {
        return array(
            'gateway' => $this->config['transaction_url'] . '/payment/do.html',
            'args' => $this->args
        );
    }

    public function getpayinfo()
    {
        define('TRADENO', isset($_POST['transaction_id']) ? $_POST['transaction_id'] : null);
        define('ORDERID', isset($_POST['trade_order_id']) ? $_POST['trade_order_id'] : $_GET['orderid']);
        return array(
            'succeed' => 'success',
            'fail' => 'fail'
        );
    }

    public function pricecheck($price)
    {
        return true;
    }

    public function notifycheck()
    {
        $data = $_POST;
        if (isset($data['plugins']) && $data['plugins'] != 'dz-wechat') {
            return false;
        }
        $appkey = $this->config['appsecret'];
        $hash = $this->generate_xh_hash($data, $appkey);
        return $data['hash'] == $hash;
    }
}

class wechatopen_mobilepay extends wechatopen_pay
{

    public function __construct()
    {
        parent::__construct();
        $this->ismobile = true;
    }

    public function setorder($order_id, $price, $subject, $body, $showurl)
    {ini_set('display_errors', 'On');
    error_reporting(E_ALL);
        global $_G;
        $data = array(
            'version' => '1.1',
            'lang' => 'zh-cn',
            'is_app' => 'Y',
            'plugins' => 'dz-wechat',
            'appid' => $this->config['appid'],
            'trade_order_id' => $order_id,
            'payment' => 'wechat',
            'total_fee' => $price,
            'title' => iconv("UTF-8", "GBK//IGNORE", $subject),
            'description' => null,
            'time' => time(),
			 'redirect' => 1,
            'notify_url' =>str_replace('http://','https://',$_G['siteurl']) . 'source/plugin/dc_pay/api/wechatopen/wechatopen_notify.php',
            'return_url' => str_replace('http://','https://',$_G['siteurl']) . 'source/plugin/dc_pay/api/wechatopen/wechatopen_return.php?orderid=' . $order_id,
            'callback_url' => str_replace('http://','https://',$_G['siteurl']),
            'nonce_str' => str_shuffle(time())
        );
		
        $hashkey = $this->config['appsecret'];
        $data['hash'] = $this->generate_xh_hash($data, $hashkey);
        $this->args = $data;
    }
}
?>