<?php
/**
 *      [Discuz!] (C)2015-2099 DARK Inc.
 *      This is NOT a freeware, use is subject to license terms
 *
 *      $Id: pay.lib.class.php 3280 2015-01-22 10:18:15Z wang11291895@163.com $
 */
if(!defined('IN_DISCUZ')) {
	exit('Access Denied');
}
class PayMent{
	private $_plugin;
	private $_paytypes;
	private $_payobj = array();
	public function __construct($plugin) {
		$this->_plugin = $plugin;
		$paytypes = @include DISCUZ_ROOT.'/source/plugin/dc_pay/data/config.php';
		foreach($paytypes as $k => $p){
			if($p['enable'])$this->_paytypes[$k]=$p;
		}
	}
	public function GetPayType(){
		$pt = array();
		foreach($this->_paytypes as $k=>$v)$pt[]=$k;
		return $pt;
	}
	public function GetPayInfo($pt){
		global $_G;
		$info = array();
		if($this->_paytypes[$pt]){
			$info = array(
				'title'=>$this->_paytypes[$pt]['title'],
				'logo'=>$_G['siteurl'].'source/plugin/dc_pay/api/'.$pt.'/'.$this->_paytypes[$pt]['logo'],
			);
		}
		return $info;
	}
	public function SetPayType($pt){
		if($this->_payobj[$pt])return;
		if($this->_paytypes[$pt]){
			C::import('api/pay','plugin/dc_pay',false);
			C::import($pt.'/pay','plugin/dc_pay/api',false);
			$modstr = $pt.'_pay';
			if (class_exists($modstr,false)){
				$this->_payobj[$pt] = new $modstr();
			}
		}
	}
	public function SetOrder($orderid = '',$price = 0, $subject = 'test', $body = '', $showurl= ''){
		global $_G;
		if(!$this->_payobj)return;
		$order = array(
			'price'=>$price,
			'subject'=>$subject,
			'uid'=>$_G['uid'],
			'username'=>$_G['username'],
			'status'=>0,
			'dateline'=>TIMESTAMP,
			'plugin'=>$this->_plugin,
			'payorderid'=>'',
		);
		$oinsert = true;
		if($orderid){
			$ord = C::t('#dc_pay#dc_pay_order')->getbyorderid($orderid);
			if($ord){
				$oinsert = false;
				C::t('#dc_pay#dc_pay_order')->update($ord['id'],$order);
			}
			$order['orderid'] = $orderid;
		}else{
			$order['orderid'] = dgmdate(TIMESTAMP, 'YmdHis').random(10,1);
		}
		
		if($oinsert){
			C::t('#dc_pay#dc_pay_order')->insert($order);
		}
		foreach($this->_payobj as $k => $obj)
			$this->_payobj[$k]->setorder($orderid, $price, $subject, $body, $showurl);
		return $orderid;
	}
	public function GetPayUrl(){
		if(!$this->_payobj)return;
		$payurl = array();
		foreach($this->_payobj as $k => $obj)
			$payurl[$k]=$this->_payobj[$k]->create_payurl();
		return $payurl;
	}
	public function GetPayForm($button_name, $button_style = '', $method = 'post'){
		if(!$this->_payobj)return;
		$payform = array();
		foreach($this->_payobj as $k =>$obj)
			$payform[$k]=$this->_payobj[$k]->create_payform($button_name, $button_style, $method);
		return $payform;
	}
}
class PayHook{
	public static function Register($data) {
		if($data['plugin'] && $data['include'] && $data['class'] && $data['return'] && $data['notify']) {
			$d = array(
				'plugin'=>$data['plugin'],
				'include'=>$data['include'],
				'class'=>$data['class'],
				'returnmethod'=>$data['return'],
				'notifymethod'=>$data['notify'],
			);
			return C::t('#dc_pay#dc_pay_api')->insert($d,true,true);
		}
	}
	public static function UnRegister($plugin) {
		return C::t('#dc_pay#dc_pay_api')->delete($plugin);
	}
}
?>